"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const od_1 = __importDefault(require("od"));
const camelcase_1 = __importDefault(require("camelcase"));
const date_1 = require("../date");
const licenses_1 = require("./licenses");
function generator(generator, userInput) {
    const [licenseLink, licenseBadge] = licenses_1.licenseBadgeMarkdown(userInput.license);
    return function generate(template, destination) {
        if (destination === undefined) {
            destination = generatedFileName(template);
        }
        generator.fs.copyTpl(generator.templatePath(template), generator.destinationPath(destination), Object.assign(Object.assign({}, userInput), { licenseLink: licenseLink, licenseBadge: licenseBadge, dateYear: od_1.default.get('year', date_1.now()), exportStatement: generator.options.default
                ? 'export default'
                : 'export', importStatement: generator.options.default
                ? camelcase_1.default(userInput.packageNameKebabCase)
                : ['{', camelcase_1.default(userInput.packageNameKebabCase), '}'].join(' '), npmInstallFrom: userInput.license === 'SEE LICENSE IN <LICENSE>'
                ? `git+ssh://git@${userInput.gitHost}/${userInput.gitGroup}/${userInput.packageNameKebabCase}`
                : userInput.scopedPackageName }));
    };
}
exports.generator = generator;
function generatedFileName(templateFileName) {
    return templateFileName
        .replace(/^.*\//, '')
        .replace(/_dot_/g, '.')
        .replace(/dot_/g, '.');
}
exports.generatedFileName = generatedFileName;
