"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isDebugMode() {
    return process.env.PRODUCTION === undefined
        && process.env.DEBUG !== undefined;
}
/* eslint-disable @typescript-eslint/no-explicit-any */
function mockDebugger(tag) {
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    function format(_formatter, ..._args) { }
    Object.defineProperties(format, {
        color: {
            value: ''
        },
        enabled: {
            value: false
        },
        log: {
            value: function log(..._args) { return false; }
        },
        namespace: {
            value: tag
        },
        destroy: {
            value: () => true
        },
        extend: {
            value: function extend(namespace, delimiter) {
                return mockDebugger([tag, namespace].join(delimiter || ':'));
            }
        }
    });
    return format;
}
/* eslint-enable @typescript-eslint/no-explicit-any */
/* eslint-disable @typescript-eslint/no-var-requires */
function debug(tag) {
    return isDebugMode()
        ? require('debug')(tag)
        : mockDebugger(tag);
}
exports.debug = debug;
/* eslint-enable @typescript-eslint/no-var-requires */
