"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable security/detect-object-injection */
function memoize(f) {
    const memory = Object.create(null);
    return function memoized(...args) {
        const key = JSON.stringify(args);
        if (key in memory) {
            return memory[key];
        }
        const result = f(...args);
        memory[key] = result;
        return result;
    };
}
exports.memoize = memoize;
/* eslint-enable @typescript-eslint/no-explicit-any */
/* eslint-enable security/detect-object-injection */
